/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#ifndef INCL_XMLSTREAM_H
#define INCL_XMLSTREAM_H

#define XMLSTREAM_ROOT 0	/* got <stream> tag */
#define XMLSTREAM_NODE 1	/* got <message>, <presence> or <iq> tag */
#define XMLSTREAM_CLOSE 2	/* got </stream> tag */
#define XMLSTREAM_XMLERR 3	/* bad xml data */
#define XMLSTREAM_SOCKERR 4	/* network error */

/* starts streaming on given connection */
void xmlstream_start(jnixc j, xmlnode x);
/* creates a header node for xmlstream_start */
xmlnode xmlstream_header(char *namespace, char *to, char *from);

/* stops streaming, if f!=0 sends </stream> tag */
/* if err!=NULL sends an error msg too */
void xmlstream_stop(jnixc j, int f, char *err);

/* functions for sending/receiving xml data */
void xmlstream_write(jnixc j, char *buf);
void xmlstream_read(jnixc j);



#endif
