/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "jnix.h"
#include "xmlstream.h"


void jnix_auth(jnixc j, char *user, char *pass)
{
	jnixn node;
	jid id;

	if (JNIX_STATE_ONLINE != j->state) return;

	node = jnix_newNode(JNIXN_IQ, JNIXN_TYPE, JNIXQ_TYPE_SET,
			JNIXQ_XMLNS, "jabber:iq:auth", JNIXN_DONE);
	id = jid_new(node->jn.p,user);
	jnix_addItem(node,NULL,"username",id->user,NULL);
	jnix_addItem(node,NULL,"resource",id->resource,NULL);
	jnix_addItem(node,NULL,"password",pass,NULL);
	jnix_sendNode(j,node);
	jnix_freeNode(node);
}


void jnix_register(jnixc j, char *username, char *pass)
{
	jnixn node;

	if (JNIX_STATE_ONLINE != j->state) return;

	node = jnix_newNode(JNIXN_IQ, JNIXN_TYPE, JNIXQ_TYPE_SET,
			JNIXQ_XMLNS, "jabber:iq:register", JNIXN_DONE);
	jnix_addItem(node,NULL,"username",username,NULL);
	jnix_addItem(node,NULL,"password",pass,NULL);
	jnix_sendNode(j,node);
	jnix_freeNode(node);
}


jnixa _jnix_parseAuth(int f, jnixn node)
{
	pool p;
	jnixa a;
	jnixitem tmp1,tmp2;

	if (node->jn.type != JNIXQ_TYPE_RESULT) return(NULL);

	p = pool_new();
	if (!p) return(NULL);
	a = (jnixa)pmalloc(p,sizeof(_jnixa));
	if (!a) return(NULL);
	memset(a,0,sizeof(_jnixa));
	a->p = p;

	if (0==f) a->type=JNIXA_FAIL; else a->type=JNIXA_REGFAIL;

	if (node->jn.to) a->user = node->jn.to;
	tmp1 = jnix_findItem(node->jq.items,"error");
	if (tmp1) {
			a->msg = pstrdup(p, tmp1->value);
	} else {
		if (0==f) a->type=JNIXA_OK; else a->type=JNIXA_REGOK;
	}

	return(a);
}


void jnix_freeAuth(jnixa a)
{
	pool_free(a->p);
}
